mod Ex08a

incl Mtex

incl Mtexbt

incl Mauxa

loc rem 
  \para \bf  8. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 8.4.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0708ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane binarnym stromom. 
  Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  Chapter. Programs Operating on Trees.  \end 

rem 
  \para \bf  Section. Binary Trees.  \end 

rem 
  \para \bf  Arithmetization of labelled binary trees.  \end 

fun/0 E 'Tex_f0_bt_e'
  E = 0,0

fun/3 Nd 'Tex_f3_bt_nd'
  Nd(x,l,r) = 1,x,l,r

rem 
  \para \bf  [CL] Discrimination on the constructors of binary trees.  \end 
  Example(s): 
  \def 
    fun F 'Tex_f1_f'
    F(E) = Foo
    F Nd(x,l,r) = Foo
  \end

rem 
  \para \bf  Binary trees.  \end 

pred Bt 
  Bt(E)
  Bt Nd(x,l,r) <- N(x) & Bt(l) & Bt(r)

rem 
  \para \bf  [CL] Formatting the output.  \end Use the format \ft Bt \end to 
  display numbers as binary trees. Try out the following simple queries 
  \verbatim 
      171386336145149 = t:Bt
  \end
  \verbatim 
      1,10,(1,11,(0,0),0,0),(1,12,(0,0),0,0) = t:Bt
  \end

rem 
  \para \bf  Building a tree.  \end The function \ft Ln2bt(x) \end converts a 
  list of labels \ft x \end into a balanced binary tree. You can use the 
  operation to test your solutions in the following exercises. 

fun/2 Ln2bt1 'Tex_f2_f'
  Ln2bt1(0,x) = E
  Ln2bt1(S1(n),v,w) = Nd(v,Ln2bt1(n,Take(n,w)),Ln2bt1(n,Drop(n,w)))
  Ln2bt1(S2(n),v,w) = Nd(v,Ln2bt1(n+1,Take(n+1,w)),Ln2bt1(n,Drop(n+1,w)))

fun Ln2bt 
  Ln2bt(x) = Ln2bt1(L(x),x)

rem 
  \para \bf  Size and depth of binary trees.  \end 
  \header* fun Sz 'Tex_f1_bt_sz' \end \header* fun Dp 'Tex_f1_bt_dp' \end Define 
  the functions \ft Sz(t) \end and \ft Dp(t) \end computing respectively the 
  size and the depth of the binary tree \ft t \end. Note that we have 
  \eq* 
    Bt(t) -> Dp(t) <= Sz(t) & Sz(t) < Exp(2,Dp(t))
  \end

fun Sz 'Tex_f1_bt_sz'
  Sz(t) = Foo

fun Dp 'Tex_f1_bt_dp'
  Dp(t) = Foo

rem 
  \para \bf  Membership in binary trees.  \end 
  \header* pred/2 Inbt 'Tex_p2_bt_in' \end Define the predicate 
  \ft Inbt(x,t) \end such that 
  \eq* 
    ~Inbt(x,E)
  \end
  \eq* 
    Inbt(x,Nd(y,l,r)) <-> x = y \/ Inbt(x,l) \/ Inbt(x,r)
  \end

pred/2 Inbt 'Tex_p2_bt_in'
  Inbt(x,t) <- Poo

rem 
  \para \bf  Reflection function.  \end Define the function \ft Reflect(t) \end 
  which yields the mirror's image of the binary tree \ft t \end. 

fun Reflect 
  Reflect(t) = Foo

rem 
  \para \bf  Traversals of binary trees.  \end 

fun Preorder 'Tex_f1_bt_preorder'
  Preorder(t) = Foo

fun Inorder 'Tex_f1_bt_inorder'
  Inorder(t) = Foo

fun Postorder 'Tex_f1_bt_postorder'
  Postorder(t) = Foo

rem 
  \para \bf  Fast programs for tree traversals.  \end Save the concatenation in 
  the definition of each tree traversal function. 

rem 
  \para \it  Fast preorder traversal.  \end 

fun/2 Preordera 'Tex_f2_f'
  Preordera(t,a) = Foo

rem 
  \para Invariant: 
  \eq* 
    Bt(t) -> Preordera(t,a) = Preorder(t)++a
  \end

fun Preorder_fast 'Tex_f1_bt_preorder'
  Preorder_fast(t) = Foo

rem 
  \para \it  Fast inorder traversal.  \end 

fun Inorder_fast 'Tex_f1_bt_inorder'
  Inorder_fast(t) = Foo

rem 
  \para \it  Fast postorder traversal.  \end 

fun Postorder_fast 'Tex_f1_bt_postorder'
  Postorder_fast(t) = Foo

rem 
  \para \bf  Full binary trees.  \end A binary tree \ft t \end is said to be 
  \it  full  \end if 
  \eq* 
    Sz(t)+1 = Exp(2,Dp(t))
  \end

rem 
  \para \bf  Exercise.  \end \header* fun/2 Fs 'Tex_f2_f' \end Define the 
  function \ft Fs(n,x) \end such that 
  \eq* 
    Bt Fs(n,x)
  \end
  \eq* 
    Dp Fs(n,x) = n
  \end
  \eq* 
    Sz Fs(n,x)+1 = Exp(2,n)
  \end
  \eq* 
    Inbt(y,Fs(n,x)) -> y = x
  \end

fun/2 Fs 'Tex_f2_f'
  Fs(n,x) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Fpr 'Tex_f1_f' \end Define the 
  function \ft Fpr(n) \end such that 
  \eq* 
    Bt Fpr(n)
  \end
  \eq* 
    Dp Fpr(n) = n
  \end
  \eq* 
    Sz Fpr(n)+1 = Exp(2,n)
  \end
  \eq* 
    Preorder Fpr(n) = Interval(0,Exp(2,n)-1)
  \end
  \para \it  Hint.  \end \header* fun/2 Fpr1 'Tex_f2_g' \end Define first an 
  auxiliary function \ft Fpr1(n,m) \end such that 
  \eq* 
    Bt Fpr1(n,m)
  \end
  \eq* 
    Dp Fpr1(n,m) = n
  \end
  \eq* 
    Sz Fpr1(n,m)+1 = Exp(2,n)
  \end
  \eq* 
    Preorder Fpr1(n,m) = Interval(m,m+Exp(2,n)-1)
  \end

fun/2 Fpr1 'Tex_f2_g'
  Fpr1(n,m) = Foo

fun Fpr 'Tex_f1_f'
  Fpr(n) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Fin 'Tex_f1_f' \end Define the 
  function \ft Fin(n) \end such that 
  \eq* 
    Bt Fin(n)
  \end
  \eq* 
    Dp Fin(n) = n
  \end
  \eq* 
    Sz Fin(n)+1 = Exp(2,n)
  \end
  \eq* 
    Inorder Fin(n) = Interval(0,Exp(2,n)-1)
  \end

fun Fin 'Tex_f1_f'
  Fin(n) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Fpo 'Tex_f1_f' \end Define the 
  function \ft Fpo(n) \end such that 
  \eq* 
    Bt Fpo(n)
  \end
  \eq* 
    Dp Fpo(n) = n
  \end
  \eq* 
    Sz Fpo(n)+1 = Exp(2,n)
  \end
  \eq* 
    Postorder Fpo(n) = Interval(0,Exp(2,n)-1)
  \end

fun Fpo 'Tex_f1_f'
  Fpo(n) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Fbr 'Tex_f1_f' \end Define the 
  function \ft Fbr(n) \end which creates a full binary tree \ft t \end of depth 
  \ft n \end with values \ft 0,1,2,3,Tex0_dotsc \end stored in \ft t \end in 
  breadth-first order. We have 
  \eq* 
    Bt Fbr(n)
  \end
  \eq* 
    Dp Fbr(n) = n
  \end
  \eq* 
    Sz Fbr(n)+1 = Exp(2,n)
  \end
  \eq* 
    Inbt(x,Fbr(n)) <-> x+1 < Exp(2,n)
  \end
  \para \it  Hint.  \end \header* fun/2 Fbr1 'Tex_f2_g' \end Define first an 
  auxiliary function \ft Fbr1(n,k) \end such that 
  \eq* 
    Bt Fbr1(n,k)
  \end
  \eq* 
    Dp Fbr1(n,k) = n
  \end
  \eq* 
    Sz Fbr1(n,k)+1 = Exp(2,n)
  \end
  \eq* 
    Inbt(x,Fbr1(n,k)) <-> \e y(x = Dconc(k,y) & y+1 < Exp(2,n))
  \end
  \para Here \ft Dconc(x,y) \end is dyadic concatenation. 

fun/2 Fbr1 'Tex_f2_g'
  Fbr1(n,k) = Foo

fun Fbr 'Tex_f1_f'
  Fbr(n) = Foo

rem 
  \para \bf  Isomorphic binary trees.  \end 

pred/2 Isomorphic 'Tex_p2_bt_isomorphic'
  Isomorphic(E,E)
  Isomorphic(Nd(x1,l1,r1),Nd(x2,l2,r2)) <- Isomorphic(l1,l2) & Isomorphic(r1,r2)

rem 
  \para We have 
  \eq* 
    Bt(t) -> Isomorphic(t,t)
  \end
  \eq* 
    Isomorphic(t1,t2) -> Isomorphic(t2,t1)
  \end
  \eq* 
    Isomorphic(t1,t2) & Isomorphic(t2,t3) -> Isomorphic(t1,t3)
  \end
  \eq* 
    Bt(t1) & Isomorphic(t1,t2) -> Bt(t2)
  \end
  \eq* 
    Isomorphic(t1,t2) -> Sz(t1) = Sz(t2)
  \end
  \eq* 
    Isomorphic(t1,t2) -> Dp(t1) = Dp(t2)
  \end

rem 
  \para \bf  Tree numbering.  \end Given a tree, create a new tree of the same 
  shape, but with the values at the nodes replaced by the numbers 0,1,2... in a 
  fixed order. 

rem 
  \para \bf  Exercise.  \end \header* fun Npr 'Tex_f1_f' \end Define the 
  function \ft Npr(t) \end such that 
  \eq* 
    Bt(t) -> Bt Npr(t)
  \end
  \eq* 
    Bt(t) -> Isomorphic(Npr(t),t)
  \end
  \eq* 
    Bt(t) -> Preorder Npr(t) = Interval(0,Sz(t))
  \end
  \para \it  Remark.  \end Implement the function with the help of the size 
  function \ft Sz(t) \end. 
  \para \it  Hint.  \end \header* fun/2 Npr1 'Tex_f2_g' \end Define first an 
  auxiliary function \ft Npr1(t,m) \end such that 
  \eq* 
    Bt(t) -> Bt Npr1(t,m)
  \end
  \eq* 
    Bt(t) -> Isomorphic(Npr1(t,m),t)
  \end
  \eq* 
    Bt(t) -> Preorder Npr1(t,m) = Interval(m,m+Sz(t))
  \end

fun/2 Npr1 'Tex_f2_g'
  Npr1(t,m) = Foo

fun Npr 'Tex_f1_f'
  Npr(t) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Nin 'Tex_f1_f' \end Define the 
  function \ft Nin(t) \end such that 
  \eq* 
    Bt(t) -> Bt Nin(t)
  \end
  \eq* 
    Bt(t) -> Isomorphic(Nin(t),t)
  \end
  \eq* 
    Bt(t) -> Inorder Nin(t) = Interval(0,Sz(t))
  \end

fun Nin 'Tex_f1_f'
  Nin(t) = Foo

rem 
  \para \bf  Exercise.  \end \header* fun Npo 'Tex_f1_f' \end Define the 
  function \ft Npo(t) \end such that 
  \eq* 
    Bt(t) -> Bt Npo(t)
  \end
  \eq* 
    Bt(t) -> Isomorphic(Npo(t),t)
  \end
  \eq* 
    Bt(t) -> Postorder Npo(t) = Interval(0,Sz(t))
  \end

fun Npo 'Tex_f1_f'
  Npo(t) = Foo

